<?php
require_once('globalfunctions.inc.php');
require_once('mssql.server.php');




function com_getObjFakt()
{
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	global $global_obj_fakt;
	
	if( !$global_obj_fakt && (!$global_obj_fakt->ApplicationReady) )
	{
		// Erstellt das COM Object XFakt.App Selectline
		$objFakt = new COM('XFakt.App', null, CP_UTF8); // CP_UTF8 in php.ini gesetzt funktioniert nicht
	
		// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
		while (!$objFakt->ApplicationReady):
			sleep(0.1);
		endwhile;
	
		// Logt sich beim Mandant ein
		$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
			 
		// Überprüft, ob das Login funktioniert hat
		//$objFakt->LoginReady;
		//while (!$objFakt->LoginReady):
		//endwhile;
			
		// Stellt den aktuellen Mandant ein
		$objFakt->GetMandant($sl_mandant, 0);
	
		$objFakt->SetzeOptionen('Stiller Modus;1');
	
		// Liefert die Nummer des aktuellen ausgewählten Mandanten
		//$objFakt->Mandant;
		
		$global_obj_fakt=$objFakt;
	}
	
	
	return $global_obj_fakt;
}










/**
 * Beleg updaten über die COM-Schnittstelle
 * @param int $BelegNummer		Belegnummer
 * @param string $Data			serialisiertes array
 * @return int					Anzahl modifizierter Felder
 */
function com_BelegSet($BelegNummer, $Data)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;

	log_msg(__FUNCTION__ . '($BelegNummer="' . $BelegNummer . '", $Data="' . $Data . '")' );

	$aData=unserialize($Data);
	//$aData=json_decode($Data);
	//log_msg(print_r($aData,true));
	if(!is_array($aData)) die(log_msg( __FUNCTION__ . '(): $Data ist kein Array.' ));
	
	if(empty($BelegNummer)) die(log_msg( __FUNCTION__ . '(): $BelegNummer ist nicht gesetzt.' ));
	
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8); // CP_UTF8 in php.ini gesetzt funktioniert nicht

	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while (!$objFakt->ApplicationReady):
		sleep(0.1);
	endwhile;

	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
		 
	// Überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
		
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);

	$objFakt->SetzeOptionen('Stiller Modus;1');

	// Liefert die Nummer des aktuellen ausgewählten Mandanten
	//$objFakt->Mandant;

	// Sucht Beleg mit Belegnummer
	try {
		$aoBeleg=json_decode(getAuftragByBelegnummer($BelegNummer));
		$oBeleg=$aoBeleg[0];
		$SelectLineAuftrag = $objFakt->EditBeleg('F', $BelegNummer);
		if(!$SelectLineAuftrag) throw new Exception('Beleg [' . $BelegNummer . '] nicht gefunden.');
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . ': FEHLER beim Ausführen von: $objFakt->EditBeleg("F", $BelegNummer="' . $BelegNummer . '")');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	$iModifiedFields=0;
	foreach($aData as $key => $val)
	{
		if($val === null) continue;
		switch($key)
		{
			case 'benutzer':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('UnserZeichen', $val);
				$iModifiedFields++;
				break;

			case 'status_id':
				$EDIStatus='';
				if($val == 1) $EDIStatus='O';
				if($val == 2) $EDIStatus='B';
				if($val == 3) $EDIStatus='V';
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$EDIStatus.'"');
				if( $EDIStatus != '') $SelectLineAuftrag->PutField('EDIStatus', $EDIStatus);
				$iModifiedFields++;
				break;

			case 'freiezahl3':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('FreieZahl3', $val);
				$iModifiedFields++;
				break;
				
/*
			case 'projekt_id':
				log_msg('com_BelegSet(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->SetIhrAuftrag($val);
				$iModifiedFields++;
				break;
 */

			case 'kundennummer':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				//log_msg($SelectLineAuftrag->GetField('Adressnummer'));
				if( $val != $SelectLineAuftrag->GetField('Adressnummer') )
					$SelectLineAuftrag->SetAdresse($val);
				$iModifiedFields++;
				break;

			case 'name':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->SetIhrAuftrag($val);
				$iModifiedFields++;
				break;

			case 'ansprechpartner':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('IhrZeichen', $val);
				$iModifiedFields++;
				break;


			default:
				log_msg(__FUNCTION__ . '(): NOT IMPLEMENTED '.$key.' = "'.$val.'"');
		}
	}
	
	if($iModifiedFields > 0)
	{
		$syncEntryId=setSyncEntry('LOCK', 'BELEG', $oBeleg->BELEG_ID);
		$SelectLineAuftrag->Save();
		removeSyncEntry($syncEntryId);
	}
	
	return $iModifiedFields;
}




/**
 * Legt einen neuen Beleg vom Typ $BelegTyp an.
 * @param string $BelegTyp		Belegtyp (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)
 * @return string				serialisiertes Array (BELEG_ID, Belegnummer)
 */
function com_BelegNeuerBeleg($BelegTyp)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;

	log_msg(__FUNCTION__ . '($BelegTyp="' . $BelegTyp . '")' );
	
	
	if(empty($BelegTyp)) die(log_msg( __FUNCTION__ . '(): $BelegTyp ist nicht gesetzt.' ));
	
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8); // CP_UTF8 in php.ini gesetzt funktioniert nicht

	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while (!$objFakt->ApplicationReady):
		sleep(0.1);
	endwhile;
	
	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
	
	// Überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
	
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);

	$objFakt->SetzeOptionen('Stiller Modus;1');

	// Liefert die Nummer des aktuellen ausgewählten Mandanten
	//$objFakt->Mandant;

	// Legt Beleg an mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)              
	try {
		$SelectLineAuftrag = $objFakt->NeuerBelegAuto($BelegTyp);
	} catch (Exception $e)
	{
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}

	$BELEG_ID=$SelectLineAuftrag->GetField('');
	$Belegnummer=$SelectLineAuftrag->GetField('Belegnummer');

	$mssqlAuftrag=json_decode(getAuftragByBelegnummer($Belegnummer));

	$a=array(
		'BELEG_ID' => $mssqlAuftrag[0]->BELEG_ID,
		'Belegnummer' => $Belegnummer,
	);

	log_msg(__FUNCTION__ . '(): Beleg angelegt mit BELEG_ID=' . $mssqlAuftrag[0]->BELEG_ID . ' | Belegnummer=' . $Belegnummer);

	return serialize($a);
}



/**
 * Legt einen neuen Beleg vom Typ $BelegTyp an und fügt die Positionen hinzu.
 * @param string $BelegTyp		Belegtyp (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)
 * @param string $data			Daten für Positionen
 * @return string				serialisiertes Array (BELEG_ID, Belegnummer)
 */
function com_BelegNeuerBelegFull($BelegTyp, $data)
{
// 	log_msg(__FUNCTION__ . '($BelegTyp=' . var_export($BelegTyp, true) . ', $data=' . var_export($data, true) . ')' );
	log_msg(__FUNCTION__ . '($BelegTyp=' . var_export($BelegTyp, true) . ', $data=[...])' );
	
	
	if(empty($BelegTyp)) die(log_msg( __FUNCTION__ . '(): $BelegTyp ist nicht gesetzt.' ));
	if(empty($data)) die(log_msg( __FUNCTION__ . '(): $data ist nicht gesetzt.' ));
	$aData=unserialize($data);
	if(!is_array($aData)) die(log_msg( __FUNCTION__ . '(): $data ist kein (serialisiertes) Array.' ));
	
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = com_getObjFakt();
	
	
	// Legt Beleg an mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)              
	try {
		$SelectLineAuftrag = $objFakt->NeuerBelegAuto($BelegTyp);
	} catch (Exception $e)
	{
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	$Belegnummer=$SelectLineAuftrag->GetField('Belegnummer');
	// Beleg über Belegnummer und Belegtyp wieder holen
	$mssqlBeleg=json_decode(getBelegByBelegnummer($Belegnummer, $BelegTyp));
	if(count($mssqlBeleg) != 1)
		die(log_msg(__FUNCTION__ . "(): Beleg (Typ {$BelegTyp}) mit Belegnummer <{$Belegnummer}> nicht gefunden (obwohl wir den grade angelegt haben sollten!)."));
	$oBeleg=$mssqlBeleg[0];
	
	$aRetBeleg=array(
		'BELEG_ID' => $oBeleg->BELEG_ID,
		'Belegnummer' => $Belegnummer,
		'Belegtyp' => $oBeleg->Belegtyp,
	);
	log_msg(__FUNCTION__ . "(): Beleg angelegt mit BELEG_ID #{$oBeleg->BELEG_ID}# | Belegnummer <{$Belegnummer}>");
	
	
	// Bestehende Sync-Aufträge für den Beleg wieder löschen
	unsetSyncEntry('', 'BELEG', $oBeleg->BELEG_ID);
	
	// Beleg-Trigger sperren
	$syncEntryIdBel=setSyncEntry('LOCK', 'BELEG', $oBeleg->BELEG_ID);
	
	
	// Auftrags-Attribute setzen
	$iModifiedFields=0;
	foreach($aData as $key => $val)
	{
		if($val === null) continue;
		switch($key)
		{
			case 'benutzer':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('UnserZeichen', $val);
				$iModifiedFields++;
				break;

			case 'status_id':
				$EDIStatus='';
				if($val == 1) $EDIStatus='O';
				if($val == 2) $EDIStatus='B';
				if($val == 3) $EDIStatus='V';
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$EDIStatus.'"');
				if( $EDIStatus != '') $SelectLineAuftrag->PutField('EDIStatus', $EDIStatus);
				$iModifiedFields++;
				break;

			case 'freiezahl3':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('FreieZahl3', $val);
				$iModifiedFields++;
				break;
				
/*
			case 'projekt_id':
				log_msg('com_BelegSet(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->SetIhrAuftrag($val);
				$iModifiedFields++;
				break;
 */

			case 'kundennummer':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				//log_msg($SelectLineAuftrag->GetField('Adressnummer'));
				if( $val != $SelectLineAuftrag->GetField('Adressnummer') )
					$SelectLineAuftrag->SetAdresse($val);
				$iModifiedFields++;
				break;

			case 'interessentennummer':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				//log_msg($SelectLineAuftrag->GetField('Adressnummer'));
				if( $val != $SelectLineAuftrag->GetField('Adressnummer') )
					$SelectLineAuftrag->SetAdresse($val);
				$iModifiedFields++;
				break;


			case 'name':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->SetIhrAuftrag($val);
				$iModifiedFields++;
				break;

			case 'ansprechpartner':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineAuftrag->PutField('IhrZeichen', $val);
				$iModifiedFields++;
				break;


			default:
// 				log_msg(__FUNCTION__ . '(): NOT IMPLEMENTED '.$key.' = "'.$val.'"');
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	// Positionen anlegen
	foreach($aData['positions'] as $pos)
	{
		// Erstellt eine Belegposition
		try {
			if(empty($pos['hauptkennung']))
				$SelectLineBelegpos = $SelectLineAuftrag->CreatePos($pos['zeilentyp']);
			else 
			{
				$oberPos=json_decode(getPosByKennung($pos['hauptkennung']));
				if(count($oberPos) != 1)
					die(log_msg(__FUNCTION__ . '(): Parent-Position mit Kennung "' . $pos['hauptkennung'] . '" nicht gefunden.'));
				
				$SelectLineBelegpos = $SelectLineAuftrag->CreateUnterPos($pos['zeilentyp'], $pos['hauptkennung']);
			}
			$SelectLineBelegpos->Save(1);
			
			
			
			$Kennung=$SelectLineBelegpos->GetKennung();
			// Position über die Kennung suchen
			$mssqlPosition=json_decode(getPositionByKennung($Kennung));
			if(count($mssqlPosition) != 1)
				die(log_msg(__FUNCTION__ . '(): Position mit Kennung "' . $Kennung . '" nicht gefunden.'));
			$oPosition=$mssqlPosition[0];
			log_msg(__FUNCTION__ . '(): Position angelegt mit BELEGP_ID=' . $oPosition->BELEGP_ID);
			
			
			// Bestehende Sync-Aufträge für die Position wieder löschen
			unsetSyncEntry('', 'BELEGP', $oPosition->BELEGP_ID);
			
			// Beleg-Trigger sperren
			$syncEntryIdPos=setSyncEntry('LOCK', 'BELEGP', $oPosition->BELEGP_ID);
			
			
		} catch (Exception $e)
		{
			log_msg($e->getMessage());
			$error_msg=$objFakt->LetzterFehler();
			log_msg(print_r($error_msg->Meldung, true));
			die();
		}
		
		
		$iModifiedFields=0;
		// Zuerst Artikelnummer setzen, falls nötig
		if(isset($pos['erpArtikelnummer']))
		{
			$key='erpArtikelnummer';
			$val=$pos['erpArtikelnummer'];
			unset($pos['erpArtikelnummer']);
			
			log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
			$SelectLineBelegpos->SetArtikel($val);
			$iModifiedFields++;
		}
		
		
		
		// Positions-Attribute setzen
		foreach($pos as $key => $val)
		{
			if($val === null) continue;
			switch($key)
			{
				
				case 'name':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->SetBezeichnung($val);
					$iModifiedFields++;
					break;
				
				case 'zusatz':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->SetZusatz($val);
					$iModifiedFields++;
					break;
				
				case 'beschreibung':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->Langtext=$val;
					$iModifiedFields++;
					break;
				
				case 'qty':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->SetEingabeMenge(round($val, 2));
					$iModifiedFields++;
					break;
				
				case 'dauerH':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->SetEingabeMenge(round($val, 2));
					$iModifiedFields++;
					break;
				
				case 'price':
					log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
					$SelectLineBelegpos->SetEinzelPreis($val);
					$iModifiedFields++;
					break;
				
				
				default:
// 					log_msg(__FUNCTION__ . '(): NOT IMPLEMENTED '.$key.' = "'.$val.'"');
			}
			
			
		}
		
		$SelectLineBelegpos->Save(1);
		$SelectLineAuftrag->Save();
		
		// Position wieder freigeben
		removeSyncEntry($syncEntryIdPos);
	}
	
	
	
	// Beleg wieder freigeben
	removeSyncEntry($syncEntryIdBel);
	
	
	return serialize($aRetBeleg);
}




/**
 * Erstellt eine Position im Beleg $Belegnummer vom Typ $Zeilentyp
 * @param string $BelegNummer		Belegnummer
 * @param string $Zeilentyp			Positions-Typ
 * @param string $Hauptkennung		Kennung der über-Position
 * @return string 					serialisiertes Array mit IDs
 */
function com_BelegCreatePos($BelegNummer, $Zeilentyp, $Hauptkennung=null)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	
	$Hauptkennung=addCurly($Hauptkennung);
	log_msg(__FUNCTION__ . '($BelegNummer="' . $BelegNummer . '", $Zeilentyp="' . $Zeilentyp . '", $Hauptkennung="' . $Hauptkennung . '")' );
	
	if(empty($BelegNummer)) die(log_msg( __FUNCTION__ . '(): $BelegNummer ist nicht gesetzt.' ));
	if(empty($Zeilentyp)) die(log_msg( __FUNCTION__ . '(): $Zeilentyp ist nicht gesetzt.' ));
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8);

	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while (!$objFakt->ApplicationReady):
		sleep(0.1);
	endwhile;

	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
	
	// Überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
	
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);

	$objFakt->SetzeOptionen('Stiller Modus;1');
	
	
	
	// Beleg über die Belegnummer der Position holen
	$mssqlBeleg=json_decode(getAuftragByBelegnummer($BelegNummer));
	if(count($mssqlBeleg) != 1)
		die(log_msg(__FUNCTION__ . '(): Beleg mit Belegnummer "' . $mssqlPosition[0]->Belegnummer . '" nicht gefunden.'));
	
	$oBeleg=$mssqlBeleg[0];
	
	
	// Sucht Beleg mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)              
	try {
		$SelectLineAuftrag = $objFakt->EditBeleg('F', $BelegNummer);
	} catch (Exception $e)
	{
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}


	switch($Zeilentyp) {
		case 'A': // Artikel
		case 'Items':
		case 'Leistungen':
			$Zeilentyp='A';
			break;

		case 'K': // Kommentar
		case 'Notizen':
			$Zeilentyp='K';
			break;

		case 'Z': // Zwischensumme
			$Zeilentyp='Z';
			break;

		case 'T': // Teilsumme
			$Zeilentyp='T';
			break;

		case 'H': // Handelsstückliste
			$Zeilentyp='H';
			break;

		case 'G': // Unterartikel
			$Zeilentyp='G';
			break;

		case 'W': // Seitenwechsel
			$Zeilentyp='W';
			break;

		case 'S': // Gliederungssumme
		case 'Aufgaben':
			$Zeilentyp='S';
			break;

		case 'E': // Versand
			$Zeilentyp='E';
			break;

		default:
			log_msg(__FUNCTION__ . '(): Unbekannter Zeilentyp "' . $Zeilentyp . '".');
			die();
			break;

	}


	// Erstellt eine Belegposition
	try {
		// Beleg-Trigger sperren
		$syncEntryIdBel=setSyncEntry('LOCK', 'BELEG', $oBeleg->BELEG_ID);
		if(empty($Hauptkennung))
			$SelectLineBelegpos = $SelectLineAuftrag->CreatePos($Zeilentyp);
		else 
		{
			$oberPos=json_decode(getPosByKennung($Hauptkennung));
			if(count($oberPos) != 1)
				die(log_msg(__FUNCTION__ . '(): Parent-Position mit Kennung "' . $Hauptkennung . '" nicht gefunden.'));
			
			$SelectLineBelegpos = $SelectLineAuftrag->CreateUnterPos($Zeilentyp, $Hauptkennung);
		}
		$SelectLineBelegpos->Save(1);
	} catch (Exception $e)
	{
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}

	//	$BELEGP_ID=$SelectLineBelegpos->GetField('');
	//$Belegnummer=$SelectLineBelegpos->GetField('Belegnummer');
	$Kennung=$SelectLineBelegpos->GetKennung();
	
	
	// Position über die Kennung suchen
	$mssqlPosition=json_decode(getPosByKennung($Kennung));
	if(count($mssqlPosition) != 1)
		die(log_msg(__FUNCTION__ . '(): Position mit Kennung "' . $Kennung . '" nicht gefunden.'));
	$oPosition=$mssqlPosition[0];
	
	
	
	// Bestehende Sync-Aufträge löschen
	unsetSyncEntry('', 'BELEGP', $oPosition->BELEGP_ID);
	// Beleg wieder freigeben
	removeSyncEntry($syncEntryIdBel);
	
	
	$a=array(
		'BELEGP_ID' => $oPosition->BELEGP_ID,
		'Belegnummer' => $oPosition->Belegnummer,
		'Posnummer' => $oPosition->Posnummer,
		'Kennung' => $Kennung,
	);
	
	log_msg(__FUNCTION__ . '(): Position angelegt mit ' . print_r($a, true));

	return serialize($a);
}




/**
 * Findet einen Beleg anhand der $BelegNummer über die COM-Schnittstelle
 * @param string $BelegNummer			Belegnummer
 * @return string						serialisiertes Array
 */
function com_BelegGet($BelegNummer)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	
	log_msg(__FUNCTION__ . '($BelegNummer="' . $BelegNummer . '")' );
	
	if(empty($BelegNummer)) die(log_msg( __FUNCTION__ . '(): $BelegNummer ist nicht gesetzt.' ));
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8); // CP_UTF8 in php.ini gesetzt funktioniert nicht
	
	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while(!$objFakt->ApplicationReady) sleep(0.1);
	
	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
		
	// überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
	
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);
	
	$objFakt->SetzeOptionen('Stiller Modus;1');
	
	// Liefert die Nummer des aktuell ausgewählten Mandanten
	//$objFakt->Mandant;

	// Sucht Beleg mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)              
	try {
		$SelectLineAuftrag = $objFakt->EditBeleg('F', $BelegNummer);
		if(!$SelectLineAuftrag) throw new Exception('Beleg [' . $BelegNummer . '] nicht gefunden.');
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Auführen von: $objFakt->EditBeleg("F", $BelegNummer="' . $BelegNummer . '")');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	
	
	$a=array(
		'IhrAuftrag' => $SelectLineAuftrag->GetField('IhrAuftrag'),
		'Belegnummer' => $SelectLineAuftrag->GetField('Belegnummer'),
	);
	
	
	
	log_msg(__FUNCTION__ . '(): Beleg gefunden mit ' . print_r($a, true));
	return serialize($a);
}




/**
 * Position updaten über die COM-Schnittstelle
 * @param string $Kennung		Positionskennung
 * @param string $Data			serialisiertes Array
 * @return int					Anzahl modifizierter Felder
 */
function com_PositionSet($Kennung, $Data)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	
	
	$Kennung='{' . str_replace(array('{', '}'), array('', ''), $Kennung) . '}';

	log_msg(__FUNCTION__ . '($Kennung="' . $Kennung . '", $Data="' . $Data . '")' );

	$aData=unserialize($Data);
	//log_msg(print_r($aData,true));
	if(!is_array($aData)) die(log_msg( __FUNCTION__ . '(): $Data ist kein Array.' ));
	
	if(empty($Kennung)) die(log_msg( __FUNCTION__ . '(): $Kennung ist nicht gesetzt.' ));
	
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8);

	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while (!$objFakt->ApplicationReady):
		sleep(0.1);
	endwhile;

	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
		 
	// Überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
	
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);

	$objFakt->SetzeOptionen('Stiller Modus;1');
	
	
	// Position über die Kennung suchen
	$mssqlPosition=json_decode(getPosByKennung($Kennung));
	if(count($mssqlPosition) != 1) {
		die(log_msg(__FUNCTION__ . '(): Position mit Kennung "' . $Kennung . '" nicht gefunden.'));
		//return 0;
	}
	$oPosition=$mssqlPosition[0];

	// Eltern-Position über die Kennung suchen
	$oElternPosition=null;
	if(!empty($oPosition->Hauptkennung))
	{
    $mssqlElternPosition=json_decode(getPosByKennung($oPosition->Hauptkennung));
    if(count($mssqlElternPosition) != 1) {
      die(log_msg(__FUNCTION__ . '(): Eltern-Position mit Kennung "' . $oPosition->Hauptkennung . '" nicht gefunden.'));
      //return 0;
    }
    $oElternPosition=$mssqlElternPosition[0];
  }
	
	// Beleg über die Belegnummer der Position holen
	$mssqlBeleg=json_decode(getAuftragByBelegnummer($mssqlPosition[0]->Belegnummer));
	if(count($mssqlBeleg) != 1)
		die(log_msg(__FUNCTION__ . '(): Beleg mit Belegnummer "' . $mssqlPosition[0]->Belegnummer . '" nicht gefunden.'));
	$oBeleg=$mssqlBeleg[0];
	
	// Sucht Beleg mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)
	try {
		$SelectLineAuftrag = $objFakt->EditBeleg($mssqlPosition[0]->Belegtyp, $mssqlPosition[0]->Belegnummer);
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Ausführen von: $objFakt->EditBeleg($mssqlPosition[0]->Belegtyp="' . $mssqlPosition[0]->Belegtyp . '", $mssqlPosition[0]->Belegnummer="' . $mssqlPosition[0]->Belegnummer . '")');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	try {
		$SelectLineBelegpos = $SelectLineAuftrag->EditPos($Kennung);
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Ausführen von: $SelectLineAuftrag->EditPos($Kennung="' . $Kennung . '");');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	
	try {
		$TableKey='BP';
		//$PrimaryKey=$mssqlPosition[0]->BELEGP_ID;
		$PrimaryKey=$Kennung;
		$SelectLineBelegposTable = $objFakt->CreateTable($TableKey);
		if( !$SelectLineBelegposTable->FindKey($PrimaryKey) ) throw new Exception('Position [' . $PrimaryKey . '] nicht gefunden.');
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Ausführen von: $objFakt->CreateTable($TableKey="' . $TableKey . '");');
		log_msg('ORDER $SelectLineBelegposTable->FindKey($PrimaryKey="' . $PrimaryKey . '")');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
 
	$iModifiedFields=0;


	// Zuerst Artikelnummer setzen, falls nötig
	if(isset($aData['erpArtikelnummer']))
	{
		$key='erpArtikelnummer';
		$val=$aData['erpArtikelnummer'];
		unset($aData['erpArtikelnummer']);

		log_msg('com_PositionSet(): '.$key.' = "'.$val.'"');
		$SelectLineBelegpos->SetArtikel($val);
		$iModifiedFields++;
	}


	foreach($aData as $key => $val)
	{
		if($val === null) continue;
		switch($key)
		{

			case 'name':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->SetBezeichnung($val);
				$iModifiedFields++;
				break;

			case 'zusatz':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->SetZusatz($val);
				$iModifiedFields++;
				break;
			
			case 'beschreibung':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->Langtext=$val;
				$iModifiedFields++;
				break;

			case 'qty':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->SetEingabeMenge(round($val, 2));
				$iModifiedFields++;
				break;

			case 'dauerH':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->SetEingabeMenge(round($val, 2));
				$iModifiedFields++;
				break;

			case 'price':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegpos->SetEinzelPreis($val);
				$iModifiedFields++;
				break;

			case 'posnum':
				log_msg(__FUNCTION__ . '(): '.$key.' = "'.$val.'"');
				$SelectLineBelegposTable->PutField('Posnummer', $val);
				$iModifiedFields++;
				if($oElternPosition)
				{
          $key2='Postext';
          $val2=$oElternPosition->Postext . '.' . $val;
          log_msg(__FUNCTION__ . '(): '.$key2.' = "'.$val2.'"');
          $SelectLineBelegpos->Postext=$val2;
          $iModifiedFields++;
        }
				break;



			default:
				log_msg(__FUNCTION__ . '(): NOT IMPLEMENTED '.$key.' = "'.$val.'"');
		}
	}

	if($iModifiedFields > 0)
	{
		$syncEntryIdPos=setSyncEntry('LOCK', 'BELEGP', $oPosition->BELEGP_ID);
		$syncEntryIdBel=setSyncEntry('LOCK', 'BELEG', $oBeleg->BELEG_ID);
		
		$SelectLineBelegposTable->Post();
		$SelectLineBelegpos->Save(1);
		$SelectLineAuftrag->Save();
		
		removeSyncEntry($syncEntryIdPos);
		removeSyncEntry($syncEntryIdBel);
	}


	return $iModifiedFields;
}




/**
 * Position löschen über die COM-Schnittstelle
 * @param string $Kennung		Positionskennung
 * @return int					Anzahl modifizierter Felder
 */
function com_PositionDelete($Kennung)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	
	
	$Kennung='{' . str_replace(array('{', '}'), array('', ''), $Kennung) . '}';
	log_msg(__FUNCTION__ . '($Kennung="' . $Kennung . '")' );
	
	
	if(empty($Kennung)) die(log_msg( __FUNCTION__ . '(): $Kennung ist nicht gesetzt.' ));
	
	
	// Erstellt das COM Object XFakt.App Selectline
	$objFakt = new COM('XFakt.App', null, CP_UTF8);

	// Wartet solange bis applicationready = TRUE; bzw. es wird solange wiederholt solange ApplicationReady FALSE ist, bei TRUE -> fortfahren
	while (!$objFakt->ApplicationReady):
		sleep(0.1);
	endwhile;

	// Logt sich beim Mandant ein
	$objFakt->Login($dc_domain."\\".$dc_user, $dc_pass);
		 
	// Überprüft, ob das Login funktioniert hat
	//$objFakt->LoginReady;
	//while (!$objFakt->LoginReady):
	//endwhile;
	
	// Stellt den aktuellen Mandant ein
	$objFakt->GetMandant($sl_mandant, 0);

	$objFakt->SetzeOptionen('Stiller Modus;1');
	
	
	// Position über die Kennung suchen
	$mssqlPosition=json_decode(getPosByKennung($Kennung));
	if(count($mssqlPosition) != 1)
		return serialize(log_msg(__FUNCTION__ . '(): Position mit Kennung "' . $Kennung . '" nicht gefunden.'));
	$oPosition=$mssqlPosition[0];
	
	// Beleg über die Belegnummer der Position holen
	$mssqlBeleg=json_decode(getAuftragByBelegnummer($mssqlPosition[0]->Belegnummer));
	if(count($mssqlBeleg) != 1)
		return serialize(log_msg(__FUNCTION__ . '(): Beleg mit Belegnummer "' . $mssqlPosition[0]->Belegnummer . '" nicht gefunden.'));
		
	$oBeleg=$mssqlBeleg[0];
	
	// Sucht Beleg mit Belegnummer (A-Angebot, F-Auftrag, L-Lieferschein, R-Rechnung, B-Bestellung, E-Eingangsrechnung)
	try {
		$SelectLineAuftrag = $objFakt->EditBeleg($mssqlPosition[0]->Belegtyp, $mssqlPosition[0]->Belegnummer);
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Ausführen von: $objFakt->EditBeleg($mssqlPosition[0]->Belegtyp="' . $mssqlPosition[0]->Belegtyp . '", $mssqlPosition[0]->Belegnummer="' . $mssqlPosition[0]->Belegnummer . '")');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	try {
		// LOCK setzen, damit die Löschaktion nicht ins CRM synchonisiert wird
		$syncEntryIdPos=setSyncEntry('LOCK', 'BELEGP', $oPosition->BELEGP_ID);
		$syncEntryIdBel=setSyncEntry('LOCK', 'BELEG', $oBeleg->BELEG_ID);
		
		$ret = $SelectLineAuftrag->DeletePos($Kennung);
	} catch (Exception $e)
	{
		log_msg(__FUNCTION__ . '(): FEHLER beim Ausführen von: $SelectLineAuftrag->DeletePos($Kennung="' . $Kennung . '");');
		log_msg($e->getMessage());
		$error_msg=$objFakt->LetzterFehler();
		log_msg(print_r($error_msg->Meldung, true));
		die();
	}
	
	// Bestehende Sync-Aufträge löschen
	unsetSyncEntry('', 'BELEGP', $oPosition->BELEGP_ID);
	// Beleg wieder freigeben
	removeSyncEntry($syncEntryIdBel);
	
	
	return serialize($ret);
}



/**
 * Exportiert ein Bild
 * @param string $erpId					BILD_ID
 * @return string						serialisiertes Array
 * @deprecated
 */
function com_BildGet($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	global $sl_mandant, $dc_domain, $dc_user, $dc_pass;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '")' );
	
	log_msg('Function "' . __FUNCTION__ . '()" is DEPRECATED!');
	
	if(empty($erpId)) die(log_msg( __FUNCTION__ . '(): $erpId ist nicht gesetzt.' ));
	
	
	$ArrRS=json_decode(getMediaByErpId($erpId));
	
	$ArrRS[0]->content=$ArrRS[0]->Bild;
	unset($ArrRS[0]->Bild);
	
	return serialize($ArrRS);
}









