<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');
require_once('mssqlFunctions.php');


$e->register('createOrUpdateInteressent', [
		'data' => 'string',
	],
	['return' => 'string'],
	'Erstellt oder aktualisiert einen Interessenten.'
);


/**
 * Erstellt oder aktualisiert einen Interessenten.
 * @param string $data
 * @return string
 */
function createOrUpdateInteressent($data)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($data="' . $data . '")' );
	
	$data=json_decode($data);
	if(!is_object($data)) die(log_msg( __FUNCTION__ . '(): $data ist kein Objekt.' ));
	unset($data->AngelegtAm);
	unset($data->AngelegtVon);
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	$filter_CRM_ADRESSEN=mssqlTableFields('CRM_ADRESSEN', $conn);
	$filter_WAWIINTERESS=mssqlTableFields('WAWIINTERESS', $conn);
	
	$INTERESS_ID=isset($data->INTERESS_ID) ? $data->INTERESS_ID : null;
// 	log_msg('$data=' . print_r($data, true));
	
	if( $INTERESS_ID )
	{
		log_msg( __FUNCTION__ . '(): Interessent mit erpID #{$INTERESS_ID}# besteht bereits.');
		// Interessent suchen
		$aInteressenten=json_decode(getInteressentByErpId($INTERESS_ID));
		if(count($aInteressenten) != 1) die(log_msg( __FUNCTION__ . '(): Interessent mit erpID ('.$INTERESS_ID.') nicht gefunden.' ));
		$interessent=$aInteressenten[0];
		
		$sql = "UPDATE CRM_ADRESSEN
					SET " . makeMssqlSetlist($data, $filter_CRM_ADRESSEN) . "
					WHERE CRM_ADRESSEN_ID='{$interessent->CRM_AdressenID}'";
		
// 		log_msg('CRM_ADRESSEN SQL=' . $sql);
		// SQL-Abrage starten
		$stmt = sqlsrv_query( $conn, $sql );
		if(!$stmt) die(log_msg(__FUNCTION__ . '(): MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
		
		
	} else
	{
		log_msg( __FUNCTION__ . '(): Interessent wird neu angelegt.');
		// Zuerst die Adresse in der Tabelle CRM_ADRESSEN anlegen ...
		$data->AngelegtAm=$data->BearbeitetAm;
		$data->AngelegtVon=$data->BearbeitetVon;
		$sql = "INSERT INTO CRM_ADRESSEN
					" . makeMssqlFieldlist($data, $filter_CRM_ADRESSEN) . "
					VALUES " . makeMssqlValuelist($data, $filter_CRM_ADRESSEN) . ";
					SELECT SCOPE_IDENTITY() AS LAST_INSERT_ID;";
		
		//log_msg('CRM_ADRESSEN SQL=' . $sql);
		// SQL-Abrage starten
		$stmt = sqlsrv_query( $conn, $sql );
		if(!$stmt) die(log_msg(__FUNCTION__ . '(): MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
		
		// ID ermitteln
		$CRM_ADRESSEN_ID=mssqlLastInsertId($stmt);
		log_msg("Adresse in CRM_ADRESSEN angelegt mit \$CRM_ADRESSEN_ID={$CRM_ADRESSEN_ID}.");
		
		
		// ... dann den Interessenten in WAWIINTERESS
		// CRM_ADRESSEN-Eintrag mit Interessent verknüpfen
		$data->CRM_AdressenID=$CRM_ADRESSEN_ID;
		
		// Neue Interessenten-Nummer anfordern, falls nötig
		if( empty($data->Nummer) )
			$data->Nummer=spNextAutoKey('IN', 'WAWIINTERESS', 'Nummer');
		
		$sql = "INSERT INTO dbo.WAWIINTERESS
					" . makeMssqlFieldlist($data, $filter_WAWIINTERESS) . "
					VALUES " . makeMssqlValuelist($data, $filter_WAWIINTERESS) . ";
				SELECT SCOPE_IDENTITY() AS LAST_INSERT_ID;";
		
		//log_msg('WAWIINTERESS SQL=' . $sql);
		// SQL-Abrage starten
		$stmt = sqlsrv_query( $conn, $sql );
		if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
		
		// ID ermitteln
		$INTERESS_ID=mssqlLastInsertId($stmt);
		log_msg("Interessent in WAWIINTERESS angelegt mit \$INTERESS_ID={$INTERESS_ID}.");
	}
	
	
	// Interessent suchen
	$aInteressenten=json_decode(getInteressentByErpId($INTERESS_ID));
	if(count($aInteressenten) != 1) die(log_msg( __FUNCTION__ . '(): Interessent mit erpID ('.$INTERESS_ID.') nicht gefunden.' ));
	$interessent=$aInteressenten[0];
	
	
	// JSON Array zurückgeben
	return makeJsonFromArray($interessent);
}



