<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('createOrUpdateItem', [
		'data' => 'string',
		'aExtrafelder' => 'string',
	],
	['return' => 'string'],
	'Erstellt oder aktualisiert ein Item (Artikel).'
);


/**
 * Erstellt oder aktualisiert ein Item (Artikel).
 * @param string $data
 * @return string
 */
function createOrUpdateItem($data, $aExtrafelder)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($data="' . $data . '")' );
	
	$data=json_decode($data);
	if(!is_object($data)) die(log_msg( __FUNCTION__ . '(): $data ist kein Objekt.' ));
	
	$aExtrafelder=unserialize($aExtrafelder);
	if(!is_array($aExtrafelder)) $aExtrafelder=[];
	$sExtrafelder='';
	foreach($aExtrafelder as $extrafeldName)
		$sExtrafelder.=", [$extrafeldName] = '" . escapeMssqlValue($data->$extrafeldName) . "'";
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$ART_ID=null;
	if( !empty($data->erpID) )
	{
		$ART_ID=$data->erpID;
		log_msg( __FUNCTION__ . '(): Artikel mit erpID ('.$ART_ID.') besteht bereits.');
		
		$sql = "UPDATE ART SET
					[Bezeichnung] = '" . escapeMssqlValue($data->name) . "',
					[Zusatz] = '" . escapeMssqlValue($data->zusatz) . "',
					[EANNummer] = '" . escapeMssqlValue($data->ean) . "'
					$sExtrafelder
					WHERE [ART_ID] = '" . escapeMssqlValue($ART_ID) . "';";
		log_msg($sql);
		$stmt = sqlsrv_query( $conn, $sql );
		if(!$stmt) die(log_msg(__FUNCTION__ . '(): MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
		
		
	} else
	{
		// Artikel anlegen
	}
	
	
	// Artikel suchen
	$aItems=json_decode(getItemByErpId($ART_ID, serialize($aExtrafelder)));
	if(count($aItems) != 1) die(log_msg( __FUNCTION__ . '(): Artikel mit erpID ('.$ART_ID.') nicht gefunden.' ));
	$item=$aItems[0];
	
	
	
	
	// JSON Array zurückgeben
	return makeJsonFromArray($item);
}



