<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getAdressByErpId', [
		'erpId' => 'integer',
	],
	['return' => 'string'],
	'Gibt Adressen mit der $erpId (ADRESS_ID) zurück.'
);


/**
 * Gibt Adressen mit der $erpId (ADRESS_ID) zurück.
 * @param int $erpId
 * @return string
 */
function getAdressByErpId($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '")' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  AD.*
					, DEB.KUNDEN_ID
					, INT.INTERESS_ID
					, TAD.TEXT AS TEXT
					, TAD.HTMLText AS HTMLText
					
			FROM dbo.ADRESS AD
				LEFT JOIN dbo.DEBITOREN  DEB  ON DEB.Nummer=RIGHT(AD.Adresstyp, LEN(AD.Adresstyp) - 3)
				LEFT JOIN dbo.WAWIINTERESS  INT  ON INT.Nummer=RIGHT(AD.Adresstyp, LEN(AD.Adresstyp) - 3)
				LEFT JOIN dbo.TEXT  TAD  ON TAD.BLOBKEY=CONCAT('AD', AD.ADRESS_ID)
			WHERE AD.ADRESS_ID = '" . escapeMssqlValue($erpId) . "'";
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	return makeJsonFromStmt($stmt);
}



