<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getBelegByBelegnummer', [
		'belegnummer' => 'string',
		'belegtyp' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt den Beleg mit der $belegnummer zurück.'
);


/**
 * Gibt den Beleg mit der $belegnummer zurück.
 * @param int $belegnummer
 * @param string $belegtyp
 * @return string
 */
function getBelegByBelegnummer($belegnummer, $belegtyp='F')
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	if( empty($belegtyp) ) $belegtyp='F';
	log_msg(__FUNCTION__ . '($belegnummer=' . var_export($belegnummer, true) . ', $belegtyp=' . var_export($belegtyp, true) . ')' );
	
	
	// Auftrag erpId holen
	if( !$erpId=getErpIdByBelegnummer($belegnummer, $belegtyp) )
		die(log_msg("Beleg mit Belegnummer <{$belegnummer}> nicht gefunden."));
	
	
	return getBelegByErpId($erpId, $belegtyp);
}



