<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getBelegByErpId', [
		'erpId' => 'integer',
		'belegtyp' => 'string',
	], [
		'return' => 'string',
	],
	'Gibt den Beleg mit der $erpId (BELEG_ID) zurück.'
);


/**
 * Gibt den Beleg mit der $erpId (BELEG_ID) zurück.
 * @param int $erpId BELEG_ID in der ERP-Datenbank
 * @param string|null $belegtyp
 * @return string
 */
function getBelegByErpId($erpId, $belegtyp=null)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId=' . var_export($erpId, true) . ', $belegtyp=' . var_export($belegtyp, true) . ')' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	if($belegtyp) $belegtypfilter="B.Belegtyp = '" . escapeMssqlValue($belegtyp) . "'";
	else $belegtypfilter='1=1';
	
	
	$sql = "SELECT	  B.*
					, CONVERT(VARCHAR(10), B.Datum, 120) AS Datum
					, CONVERT(VARCHAR(10), B.IhrAuftragVom, 120) AS IhrAuftragVom
					, TKO.TEXT AS kopf_TEXT
					, TKO.HTMLText AS kopf_HTMLText
					, TFU.TEXT AS fuss_TEXT
					, TFU.HTMLText AS fuss_HTMLText
					, D.KUNDEN_ID
					, I.INTERESS_ID
					, K.LIEFER_ID
					, P.WPROJEKT_ID
					, BELEGP_IDs=STUFF((SELECT CONCAT(';',P.BELEGP_ID) FROM dbo.BELEGP  P  WHERE P.Belegnummer = B.Belegnummer AND P.Belegtyp = B.Belegtyp ORDER BY P.Posnummer ASC
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					
			FROM dbo.BELEG  B
				LEFT JOIN dbo.DEBITOREN      D  ON D.Nummer = B.Adressnummer
				LEFT JOIN dbo.WAWIINTERESS   I  ON I.Nummer = B.Adressnummer
				LEFT JOIN dbo.KREDITOREN     K  ON K.Nummer = B.Adressnummer
				LEFT JOIN dbo.WPROJEKT       P  ON P.Id = B.Projekt
				LEFT JOIN dbo.TEXT         TFU  ON TFU.BLOBKEY=CONCAT('QF', B.Belegnummer)
				LEFT JOIN dbo.TEXT         TKO  ON TKO.BLOBKEY=CONCAT('QF°', B.Belegnummer)
			WHERE {$belegtypfilter} AND B.BELEG_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	return makeJsonFromStmt($stmt);
}




