<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getBelegnummerByErpId', [
		'erpId' => 'integer',
		'belegtyp' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die Belegnummer des Belegs mit der $erpId zurück.'
);


/**
 * Gibt die Belegnummer des Belegs mit der $erpId zurück.
 * @param int $erpId
 * @param string|null $belegtyp
 * @return string
 */
function getBelegnummerByErpId($erpId, $belegtyp=null)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId=' . var_export($erpId, true) . ', $belegtyp=' . var_export($belegtyp, true) . ')' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	if($belegtyp) $belegtypfilter="B.Belegtyp = '" . escapeMssqlValue($belegtyp) . "'";
	else $belegtypfilter='1=1';
	
	
	$sql = "SELECT	  B.Belegnummer
			FROM dbo.BELEG  B
			WHERE {$belegtypfilter} AND B.BELEG_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	// SQL-Felddefinitionen laden
	$ArrFields = sqlsrv_field_metadata($stmt);
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['Belegnummer'];
}



