<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getErpIdByArtikelnummer', [
		'artikelnummer' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die erpId des Artikels mit der $artikelnummer zurück.'
);


/**
 * Gibt die erpId des Artikels mit der $artikelnummer zurück.
 * @param int $artikelnummer
 * @return string
 */
function getErpIdByArtikelnummer($artikelnummer)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($artikelnummer="' . $artikelnummer . '")' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	
	$sql = "SELECT dbo.ART.ART_ID
					, dbo.ART.Artikelnummer
			FROM dbo.ART
			WHERE dbo.ART.Artikelnummer = '" . escapeMssqlValue($artikelnummer) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	// SQL-Felddefinitionen laden
	$ArrFields = sqlsrv_field_metadata($stmt);
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['ART_ID'];
}



