<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getErpIdByBelegnummer', [
		'belegnummer' => 'string',
		'belegtyp' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die erpId des Belegs mit der $belegnummer zurück.'
);


/**
 * Gibt die erpId des Belegs mit der $belegnummer zurück.
 * @param string $belegnummer
 * @param string $belegtyp
 * @return string
 */
function getErpIdByBelegnummer($belegnummer, $belegtyp='F')
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	if( empty($belegtyp) ) $belegtyp='F';
	log_msg(__FUNCTION__ . '($belegnummer=' . var_export($belegnummer, true) . ', $belegtyp=' . var_export($belegtyp, true) . ')' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  B.BELEG_ID
			FROM dbo.BELEG  B
			WHERE B.Belegtyp = '" . escapeMssqlValue($belegtyp) . "' AND B.Belegnummer = '" . escapeMssqlValue($belegnummer) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	// SQL-Felddefinitionen laden
	$ArrFields = sqlsrv_field_metadata($stmt);
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['BELEG_ID'];
}



