<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getErpIdByKundennummer', [
		'kundennummer' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die erpId des Kunden mit der $kundennummer zurück.'
);


/**
 * Gibt die erpId des Kunden mit der $kundennummer zurück.
 * @param int $kundennummer
 * @return string
 */
function getErpIdByKundennummer($kundennummer)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($kundennummer="' . $kundennummer . '")' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	
	$sql = "SELECT dbo.DEBITOREN.KUNDEN_ID
					, dbo.DEBITOREN.Nummer
			FROM dbo.DEBITOREN
			WHERE dbo.DEBITOREN.Nummer = '" . escapeMssqlValue($kundennummer) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	// SQL-Felddefinitionen laden
	$ArrFields = sqlsrv_field_metadata($stmt);
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['KUNDEN_ID'];
}



