<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getErpIdByPositionKennung', [
		'kennung' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die erpId der Position mit der $kennung zurück.'
);


/**
 * Gibt die erpId der Position mit der $kennung zurück.
 * @param string $kennung
 * @return string
 */
function getErpIdByPositionKennung($kennung)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	$kennung=addCurly($kennung);
	
	log_msg(__FUNCTION__ . '($kennung=' . var_export($kennung, true) . ')' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  P.BELEGP_ID
			FROM dbo.BELEGP  P
			WHERE P.Kennung = '" . escapeMssqlValue($kennung) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	// SQL-Felddefinitionen laden
	$ArrFields = sqlsrv_field_metadata($stmt);
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['BELEGP_ID'];
}



