<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getInteressentByErpId', [
		'erpId' => 'integer',
		'aExtrafelder' => 'string'
	], [
		'return' => 'string'
	],
	'Gibt Interessenten mit der $erpId (INTERESS_ID) zurück.'
);


/**
 * Gibt Interessenten mit der $erpId (INTERESS_ID) zurück.
 * @param int $erpId INTERESS_ID in der ERP-Datenbank
 * @param array $aExtrafelder Zusätzliche Felder (wird ab v1.0.5 ignoriert, da sowieso alle Felder zurückgegeben werden)
 * @return string
 */
function getInteressentByErpId($erpId, $aExtrafelder=null)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '", $aExtrafelder)' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  D.*
					, A.*
					, INL_ADRESS_IDs=STUFF((SELECT CONCAT(';',INL.ADRESS_ID) FROM dbo.ADRESS INL WHERE INL.Adresstyp = CONCAT('INL', D.Nummer)
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, CRM_ADRESSEN_IDs=STUFF((SELECT CONCAT(';',KA.CRM_ADRESSEN_ID) FROM dbo.CRM_ADRESSEN KA WHERE KA.Hauptadresse = A.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, TME.TEXT AS mem_TEXT
					, TME.HTMLText AS mem_HTMLText
					, TIN.TEXT AS TEXT
					, TIN.HTMLText as HTMLText
					
			FROM dbo.WAWIINTERESS  D
				LEFT JOIN dbo.CRM_ADRESSEN  A  ON D.CRM_AdressenID = A.Id
				LEFT JOIN dbo.TEXT TIN ON TIN.BLOBKEY=CONCAT('IN', D.Nummer)
				LEFT JOIN dbo.TEXT TME ON TME.BLOBKEY=CONCAT('in', D.Nummer)
			WHERE D.INTERESS_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	return makeJsonFromStmt($stmt);
}



