<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getItemByArtikelnummer', [
		'artikelnummer' => 'string',
		'aExtrafelder' => 'string'
	], [
		'return' => 'string'
	],
	'Gibt den Artikel mit der $artikelnummer zurück.'
);


/**
 * Gibt den Artikel mit der $artikelnummer zurück.
 * @param int $artikelnummer
 * @param string $aExtrafelder Zusätzliche Felder (wird ab v1.0.4 ignoriert, da sowieso alle Felder zurückgegeben werden)
 * @return string
 */
function getItemByArtikelnummer($artikelnummer, $aExtrafelder)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($artikelnummer="' . $artikelnummer . '")' );
	
	
	// Artikel erpId holen
	if( !$erpId=getErpIdByArtikelnummer($artikelnummer) )
		die(log_msg("Artikel mit Artikelnummer=$artikelnummer nicht gefunden."));
	
	
	return getItemByErpId($erpId, $aExtrafelder);
}



