<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getItemByErpId', [
		'erpId' => 'integer',
		'aExtrafelder' => 'string'
	], [
		'return' => 'string'
	],
	'Gibt den Artikel mit der $erpId (ART_ID) zurück.'
);


/**
 * Gibt den Artikel mit der $erpId (ART_ID) zurück.
 * @param int $erpId ART_ID in der ERP-Datenbank
 * @param array $aExtrafelder Zusätzliche Felder (wird ab v1.0.4 ignoriert, da sowieso alle Felder zurückgegeben werden)
 * @return string JSON-String
 */
function getItemByErpId($erpId, $aExtrafelder)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '", $aExtrafelder)' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$aExtrafelder=unserialize($aExtrafelder);
	if(!is_array($aExtrafelder)) $aExtrafelder=[];
	$sExtrafelder='';
	foreach($aExtrafelder as $extrafeldName)
		$sExtrafelder.=', ART.' . $extrafeldName;
	
	
	$sql = "SELECT	  A.*
					, Lagerbestand=(SELECT SUM(Bestand) FROM dbo.SL_fnGetArtikelBestandLagergruppierung(A.Artikelnummer))
					, Lagerreserviert=(SELECT SUM(Reserviert) FROM dbo.SL_fnGetArtikelBestandLagergruppierung(A.Artikelnummer))
					, Lagerbestellt=(SELECT SUM(Bestellt) FROM dbo.SL_fnGetArtikelBestandLagergruppierung(A.Artikelnummer))
					, HA.Anzeigename AS HstName
					, dbo.SL_fnListenpreis(A.Artikelnummer, GETDATE(), 'CHF', 0, 2) AS Listenpreis
					, BILD_IDs=STUFF((SELECT CONCAT(';', B.BILD_ID) FROM dbo.BILD B WHERE CONCAT('AR', A.Artikelnummer) = B.Blobkey
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, ARTBEZ_IDs=STUFF((SELECT CONCAT(';', AB.ARTBEZ_ID) FROM dbo.ARTBEZ AB WHERE AB.Artikelnummer = A.Artikelnummer
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, TAT.TEXT AS dim_TEXT
					, TAT.HTMLText AS dim_HTMLText
					, TAI.TEXT AS inf_TEXT
					, TAI.HTMLText AS inf_HTMLText
					, TAS.TEXT AS bes_TEXT
					, TAS.HTMLText AS bes_HTMLText
					, TAR.TEXT AS TEXT
					, TAR.HTMLText as HTMLText
					
			FROM dbo.ART A
				LEFT JOIN dbo.KREDITOREN HK ON A.Hersteller = HK.Nummer
				LEFT JOIN dbo.CRM_ADRESSEN HA ON HK.CRM_AdressenID = HA.Id
				LEFT JOIN dbo.TEXT TAT ON TAT.BLOBKEY=CONCAT('AT', A.Artikelnummer)
				LEFT JOIN dbo.TEXT TAI ON TAI.BLOBKEY=CONCAT('AI', A.Artikelnummer)
				LEFT JOIN dbo.TEXT TAS ON TAS.BLOBKEY=CONCAT('AS', A.Artikelnummer)
				LEFT JOIN dbo.TEXT TAR ON TAR.BLOBKEY=CONCAT('AR', A.Artikelnummer)
			WHERE A.ART_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	// JSON Array zurückgeben
	return makeJsonFromStmt($stmt);
}



