<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getItemLangByErpId', [
		'erpId' => 'integer',
	], [
		'return' => 'string'
	],
	'Gibt Artikeltexte in allen Fremdsprachen zurück.'
);


/**
 * Gibt Artikeltexte in allen Fremdsprachen zurück.
 * @param int $erpId
 * @return string
 */
function getItemLangByErpId($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '", $aExtrafelder)' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	// Artikelnummer holen
	if( !$artikelnummer=getArtikelnummerByErpId($erpId) )
		die(log_msg("Artikel mit erpId=$erpId nicht gefunden."));
	
	
	$sql = "SELECT	  AB.*
			FROM dbo.ARTBEZ AB
			WHERE AB.Artikelnummer='" . escapeMssqlValue($artikelnummer) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	// JSON Array zurückgeben
	return makeJsonFromStmt($stmt);
}



