<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getKontaktadresseByErpId', [
		'erpId' => 'integer',
	], [
		'return' => 'string'
	],
	'Gibt die Kontaktadresse mit der erpId (CRM_ADRESSEN_ID) zurück.'
);


/**
 * Gibt die Kontaktadresse mit der erpId (CRM_ADRESSEN_ID) zurück.
 * @param int $erpId CRM_ADRESSEN_ID in der ERP-Datenbank
 * @return string
 */
function getKontaktadresseByErpId($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '")' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	
	$sql = "SELECT	  KA.*
					, CRM_PERSONENLINK_IDs=STUFF((SELECT CONCAT(';', PL2.CRM_PERSONENLINK_ID) FROM dbo.CRM_PERSONENLINK PL2 WHERE PL2.PersonID = KA.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, KUNDEN_IDs=STUFF((SELECT CONCAT(';', DEB.KUNDEN_ID) FROM dbo.DEBITOREN DEB LEFT JOIN dbo.CRM_PERSONENLINK PL3 ON PL3.AdresseID = DEB.CRM_AdressenID WHERE PL3.PersonID = KA.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, INTERESS_IDs=STUFF((SELECT CONCAT(';', INT.INTERESS_ID) FROM dbo.WAWIINTERESS INT LEFT JOIN dbo.CRM_PERSONENLINK PL4 ON PL4.AdresseID = INT.CRM_AdressenID WHERE PL4.PersonID = KA.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, TCR.TEXT AS TEXT
					, TCR.HTMLText AS HTMLText
					
			FROM dbo.CRM_ADRESSEN  KA
				LEFT JOIN dbo.TEXT              TCR  ON TCR.BLOBKEY=CONCAT('CR', KA.CRM_ADRESSEN_ID)
				
			WHERE KA.CRM_ADRESSEN_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	return makeJsonFromStmt($stmt);
}




