<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getKundeByErpId', [
		'erpId' => 'integer',
		'aExtrafelder' => 'string'
	], [
		'return' => 'string'
	],
	'Gibt den Kunden mit der $erpId (KUNDEN_ID) zurück.'
);


/**
 * Gibt den Kunden mit der $erpId (KUNDEN_ID) zurück.
 * @param int $erpId KUNDEN_ID in der ERP-Datenbank
 * @param array $aExtrafelder Zusätzliche Felder (wird ab v1.0.5 ignoriert, da sowieso alle Felder zurückgegeben werden)
 * @return string
 */
function getKundeByErpId($erpId, $aExtrafelder=null)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '", $aExtrafelder)' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  D.*
					, A.*
					, I.INTERESS_ID
					, KUL_ADRESS_IDs=STUFF((SELECT CONCAT(';', KUL.ADRESS_ID) FROM dbo.ADRESS KUL WHERE KUL.Adresstyp = CONCAT('KUL', D.Nummer)
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, CRM_ADRESSEN_IDs=STUFF((SELECT CONCAT(';', PL1A.CRM_ADRESSEN_ID) FROM dbo.CRM_PERSONENLINK PL1 LEFT JOIN dbo.CRM_ADRESSEN PL1A ON PL1.PersonID=PL1A.Id WHERE PL1.AdresseID = A.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, CRM_PERSONENLINK_IDs=STUFF((SELECT CONCAT(';', PL2.CRM_PERSONENLINK_ID) FROM dbo.CRM_PERSONENLINK PL2 WHERE PL2.AdresseID = A.CRM_ADRESSEN_ID
						FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
					, TME.TEXT AS mem_TEXT
					, TME.HTMLText AS mem_HTMLText
					, TKU.TEXT AS TEXT
					, TKU.HTMLText as HTMLText
					
			FROM dbo.DEBITOREN  D
				LEFT JOIN dbo.CRM_ADRESSEN   A  ON D.CRM_AdressenID = A.Id
				LEFT JOIN dbo.WAWIINTERESS   I  ON I.CRM_AdressenID = A.Id
				LEFT JOIN dbo.TEXT         TKU  ON TKU.BLOBKEY=CONCAT('KU', D.Nummer)
				LEFT JOIN dbo.TEXT         TME  ON TME.BLOBKEY=CONCAT('ku', D.Nummer)
			WHERE D.KUNDEN_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	return makeJsonFromStmt($stmt);
}




