<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getKundennummerByErpId', [
		'erpId' => 'integer',
	], [
		'return' => 'string'
	],
	'Gibt die Kundennummer der $erpId (KUNDEN_ID) zurück.'
);


/**
 * Gibt die Kundennummer der $erpId (KUNDEN_ID) zurück.
 * @param int $erpId
 * @return string
 */
function getKundennummerByErpId($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId="' . $erpId . '")' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	
	$sql = "SELECT dbo.DEBITOREN.KUNDEN_ID
					, dbo.DEBITOREN.Nummer
			FROM dbo.DEBITOREN
			WHERE dbo.DEBITOREN.KUNDEN_ID = '" . escapeMssqlValue($erpId) . "'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	$ArrRS=makeArrayFromStmt($stmt);
	
	// JSON Array zurückgeben
	return $ArrRS[0]['Nummer'];
}



