<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getMediaByErpId', [
		'erpId' => 'integer',
	], [
		'return' => 'string'
	],
	'Gibt die Bilder mit der $erpId (BILD_ID) zurück.'
);


/**
 * Gibt das Bild mit der $erpId (BILD_ID) zurück.
 * @param int $erpId BILD_ID in der ERP-Datenbank
 * @return string JSON-String
 */
function getMediaByErpId($erpId)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($erpId=' . var_export($erpId, true) . ')' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT	  B.*
			FROM dbo.BILD B
			WHERE B.BILD_ID = '" . escapeMssqlValue($erpId) . "'";
	
// 	log_msg($sql);
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	
	
	$ArrRS=makeArrayFromStmt($stmt, function($meta, $name, $value, &$row){
		if( $name != 'Bild' ) return $row[$name];
		
		$contentsize=strlen($value);
		$contenttype=null;
		
		$tmpfname=tempnam(sys_get_temp_dir(), 'BILD');
		log_msg($tmpfname);
		$f=fopen($tmpfname, 'w');
		fwrite($f, $value);
		fclose($f);
		
		$contentsize=filesize($tmpfname);
		if(function_exists('finfo_open'))
		{
			$finfo = finfo_open(FILEINFO_MIME_TYPE);
			$contenttype=finfo_file($finfo, $tmpfname);
			finfo_close($finfo);
		} else if(function_exists('mime_content_type'))
		{
			$contenttype=mime_content_type($tmpfname);
		} else
		{
			$contenttype='application/octet-stream';
			log_msg('Mime-Typ kann nicht ermittelt werden.');
		}
		
		$row['contentsize']=$contentsize;
		$row['contenttype']=$contenttype;
		
		log_msg("Contenttype: {$contenttype} | Contentsize: {$contentsize}");
		
		// Grosse Dateien als Download bereitstellen
		if($contentsize > 20000000)
		{
			$dlFileName="BILD_{$row['BILD_ID']}.bin";
			$dlFilePath=realpath(__DIR__ . '/../../../../tmp/bildexport/') . "/{$dlFileName}";
			copy($tmpfname, $dlFilePath);
			unset($row['Bild']);
			$row['contentfile']=$dlFileName;
		}
		
		unlink($tmpfname);
		return $row[$name];
	});
	
	
	
	
	
	// JSON Array zurückgeben
	return makeJsonFromArray($ArrRS);
}



