<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getPositionByBelegnummer', [
		'belegnummer' => 'string',
		'belegtyp' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die Positionen der $belegnummer zurück.'
);


/**
 * Gibt die Positionen der $belegnummer zurück.
 * @param string $belegnummer
 * @param string $belegtyp
 * @return string
 */
function getPositionByBelegnummer($belegnummer, $belegtyp='F')
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	if( empty($belegtyp) ) $belegtyp='F';
	log_msg(__FUNCTION__ . '($belegnummer=' . var_export($belegnummer, true) . ', $belegtyp=' . var_export($belegtyp, true) . ')' );
	
	
	// Beleg erpId holen
	if( !$erpId=getErpIdByBelegnummer($belegnummer, $belegtyp) )
	{
		log_msg("Beleg '{$belegtyp}' mit Belegnummer <{$belegnummer}> nicht gefunden.");
		return makeJsonFromArray([]);
	}
	
	
	return getPositionByErpId(null, $erpId);
}



