<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getPositionByKennung', [
		'kennung' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die Position mit der $kennung (Kennung) zurück.'
);


/**
 * Gibt die Position mit der $kennung (Kennung) zurück.
 * @param string $kennung
 * @return string
 */
function getPositionByKennung($kennung)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($kennung=' . var_export($kennung, true) . ')' );
	
	
	// Position erpId holen
	if( !$erpId=getErpIdByPositionKennung($kennung) )
	{
		log_msg("Position mit Kennung <{$kennung}> nicht gefunden.");
		return makeJsonFromArray([]);
	}
	
	
	return getPositionByErpId($erpId);
}



