<?php
require_once('globalfunctions.inc.php');
require_once('makeArrayFromStmt.php');


$e->register('getXByY', [
		'table' => 'string',
		'field' => 'string',
		'needle' => 'string',
	], [
		'return' => 'string'
	],
	'Gibt die Zeilen aus $table zurück.'
);


/**
 * Gibt die Zeilen aus $table zurück.
 * @param string $table
 * @param string $field
 * @param string $needle
 * @return string
 */
function getXByY($table, $field, $needle)
{
	global $mssqlServer, $mssqlInstanz, $mssqlUser, $mssqlPass, $mssqlDB;
	
	log_msg(__FUNCTION__ . '($table="' . $table . '", $field="' . $field . '", $needle="' . $needle . '",)' );
	
	
	$serverName = $mssqlServer . "\\" . $mssqlInstanz;
	$connectionInfo = array( "Database"=>$mssqlDB, "UID"=>$mssqlUser, "PWD"=>$mssqlPass, "CharacterSet"=>"UTF-8");
	$conn = sqlsrv_connect( $serverName, $connectionInfo);
	if( !$conn ) die(log_msg( 'MSSQL Error: ' . print_r( sqlsrv_errors(), true) ));
	
	
	$sql = "SELECT *
			FROM [dbo].[{$table}] t
			WHERE [t].[{$field}] LIKE '%" . escapeMssqlValue($needle) . "%'";
	
	
	// SQL-Abrage starten
	$stmt = sqlsrv_query( $conn, $sql );
	if(!$stmt) die(log_msg('MSSQL Error: ' . print_r( sqlsrv_errors(), true)));
	
	
	// JSON Array zurückgeben
	return makeJsonFromStmt($stmt);
}



